#ifndef HW_H
#define HW_H

#define POSREG_HW_H

	//vystupni port pro motor
	#define POSREG_OUTPORT PORTA
	//vystupy, zapne branu pro motor a sleep
	#define POSREG_OUTDDR {DDRA|=0xf;DDRA|=_BV(PA7);} // vybrane aktivuje tlacitko ako output  (PA0) DDRA|=_BV(PA0);  , potom dava PA0 ako hi a low
	//cidlo home 1-home
	#define POSREG_HOMING_INPUT (PIND&_BV(PD2))
	//
	//#define POSREG_MOTOR_PORT_HI {PORTA|=_BV(PA0);}
	//#define POSREG_MOTOR_PORT_LO {PORTA&=~_BV(PA0);}
          #define POSREG_MOTOR_PORT_HI {DDRD|=0b1111;}
          #define POSREG_MOTOR_PORT_LO {DDRD&=~0b1111;}
        //  #define POSREG_MOTOR_PORT_HI {PORTA|=0b1111;}
        //  #define POSREG_MOTOR_PORT_LO {PORTA&=~0b1111;}

	//Frekvence citace
	#define POSREG_CTC_FREQ 16000000

	#define POSREG_MINVELOCI 0.01
	// !!!Nepretizit procesor!!!
	#define POSREG_MAXVELOCI 1000.0

	#define POSREG_MINDECEL 0.01
	#define POSREG_MAXDECEL 10000

	#define POSREG_MINACCEL 0.01
	#define POSREG_MAXACCEL 10000


	//Pri pokynu go home se motor vyda smerem k cidlu po max vzdalenost POSREG_HOMING_LEN
	//Pri nalezeni cidla se motor vyda zpet o polohu POSREG_HOMING_HYSTERZ
	//pote se vyda opet k cidlu maximalne o polohu 2xPOSREG_HOMING_HYSTERZ ale jiz mensi rychlosti.
	//Po dosazeni cidla motor popojede o POSREG_HOMING_HYSTERZ dopredu a tam nastavi nulu
	//maximalni delka hledani cidla
	#define POSREG_HOMING_LEN 10000
	//rychlost 1. hrubeho vyhledavani
	#define POSREG_HOMING_VELOCI1 30
	#define POSREG_HOMING_ACCEL1 30
	//prodleva pred roztocenim v ms
	#define POSREG_HOMING_DELAY1 2000
	//rychlost 2. jemneho vyhledavani
	#define POSREG_HOMING_VELOCI2 1
	#define POSREG_HOMING_ACCEL2 10
	//prodleva pred roztocenim v ms
	#define POSREG_HOMING_DELAY2 1000
	//hysterze pro 2. navrat na cidlo a zpet do polohy 0
	#define POSREG_HOMING_HYSTERZ 20




#define USS_HW_H
	//velikost usart buferu
	#define USS_BUF_SIZ 64

	//zavola se pri inicializaci a ma to zapnout vystupni piny pro
	//rizeni toku rs485,pro leddiody
	#define USS_OUTDDR {DDRD|=_BV(PD1)|_BV(PD2);DDRC|=_BV(PC0)|_BV(PC1)|_BV(PC2);}
	//nastavy rs485 jako vysilac
	#define USS_TXEN PORTD|=_BV(PD2)
	//nastavy rs485 jako prijimac
	#define USS_RXEN PORTD&=~_BV(PD2)

	//rozsviti a zhasne diodu
	#define USS_TXLEDOFF {PORTC|=_BV(PC2);}
	#define USS_TXLEDON {PORTC&=~_BV(PC2);}
	//rozsviti a zhasne diodu
	#define USS_RXLEDOFF {PORTC|=_BV(PC1);}
	#define USS_RXLEDON {PORTC&=~_BV(PC1);}
	//rozsviti a zhasne diodu
	#define USS_ERRLEDOFF {PORTC|=_BV(PC0);}
	#define USS_ERRLEDON {PORTC&=~_BV(PC0);}

	//doba sviceni diody x10ms
	#define USS_TXLED 50
	#define USS_RXLED 10
	#define USS_ERRLED 200

#endif
