#ifndef USARTSERVO_H
#define USARTSERVO_H

 #ifndef TYPEDEFINE
 #define TYPEDEFINE
	typedef uint8_t		u8t;
	typedef uint16_t	u16t;
	typedef uint32_t	u32t;

	typedef int8_t		s8t;
	typedef int16_t		s16t;
	typedef int32_t		s32t;

	#define U8TOP ((u8t)(~0))
	#define U16TOP ((u16t)(~0))
	#define U32TOP ((u32t)(~0))

	#define S8TOP ((s8t)(((u8t)U8TOP) >>1))
	#define S8BUTT (S8TOP+1)

	#define S16TOP ((s16t)(((u16t)U16TOP) >>1))
	#define S16BUTT (S16TOP+1)

	#define S32TOP ((s32t)(((u32t)U32TOP) >>1))
	#define S32BUTT (S32TOP+1)

 #endif

#include "../hw.h"

#ifndef USS_HW_H
#define USS_HW_H
#warning HW config is default

	//velikost usart buferu
	#define USS_BUF_SIZ 64

	//zavola se pri inicializaci a ma to zapnout vystupni piny pro
	//rizeni toku rs485,pro leddiody
	#define USS_OUTDDR {DDRD|=_BV(PD1)|_BV(PD2);DDRA|=_BV(PA3)|_BV(PA4)|_BV(PA5);}
	//nastavy rs485 jako vysilac
	#define USS_TXEN PORTD|=_BV(PD2)
	//nastavy rs485 jako prijimac
	#define USS_RXEN PORTD&=~_BV(PD2)

	//rozsviti a zhasne diodu
	#define USS_TXLEDON {PORTA|=_BV(PA2);}
	#define USS_TXLEDOFF {PORTA&=~_BV(PA2);}
	//rozsviti a zhasne diodu
	#define USS_RXLEDON {PORTA|=_BV(PA3);}
	#define USS_RXLEDOFF {PORTA&=~_BV(PA3);}
	//rozsviti a zhasne diodu
	#define USS_ERRLEDON {PORTA|=_BV(PA4);}
	#define USS_ERRLEDOFF {PORTA&=~_BV(PA4);}

	//doba sviceni diody x10ms
	#define USS_TXLED 50
	#define USS_RXLED 10
	#define USS_ERRLED 200

#endif

//To servo
//{adr;cmd;...}
//{0;0;}

typedef enum{
	USS_GET_STATUS,	//{adr,0} - {adr,0,pos,AHPO}
	USS_GOTO,		//{adr,1,pos,veloci,accel} - pokud prikaz akceptuje {adr,1,pos,AHPO} -pokud prikaz neakceptuje {adr,0,pos,AHPO}
	USS_GO_HOME,	//{adr,2} - {adr,2,pos,AHPO}
	USS_SET_HOME_POS,//{adr,3,pos} - {adr,3,pos,AHPO}
	USS_TOTAL_STOP,	//{adr,4} - {adr,4,pos,AHPO}
	USS_MOTOR_LO,//{adr,5} - {adr,5,pos,AHPO}
	USS_MOTOR_HI,//{adr,6} - {adr,6,pos,AHPO}

}TUssCmdE;

//******************************************************************************
//Recv status
typedef enum{
	USS_RX_DIS,		//prijem zakazan
	USS_RX_START,	//cekam na prijeti '{'
	USS_RX_ADR,		//prijimam adresu
	USS_RX_DATA,	//prijimam data a cekam na prijeti '}'
	USS_RX_OK		//prijem dokoncen a zakazan
}TUssRecvSw;
//******************************************************************************
//Tx status
typedef enum{
	USS_TX_DIS,
	USS_TX_DATA,	//posli data
	USS_TX_OK
}TUssTransmSw;
//******************************************************************************
typedef volatile struct{
	struct{	
		u8t adr;				//adresa stanice
		u8t buf[USS_BUF_SIZ];	//buffer
	}Data;

	struct{
		u8t msI;
		u8t rxPaketI;
		u8t rxLedI;
		u8t txPaketI;
		u8t txLedI;
		u8t errLedI;
	}Diag;
	
	struct{
		TUssCmdE cmd;
		u8t rx_i;				//pocitadlo prijatych bytu bez '{''}'
		TUssRecvSw sw;
	}Recv;

	struct{
		u8t txLen;
		u8t tx_i;				//pocitadlo bytu k odeslani
		TUssTransmSw sw;
	}Transm;

}TUssBusS;
//******************************************************************************
TUssBusS UssBusS;
//******************************************************************************
void ussInit(u8t adr);
void UssRxStart(void);
void UssTxStart(void);
void Uss(void);
void Uss1ms(void);





#endif
